#include <avr/io.h>
#include <avr/interrupt.h>
#include "timers.h"

extern uint8_t tmod;

//ISR(TIMER0_COMPA_vect, ISR_NAKED)
ISR(TIMER0_COMPA_vect)
{	
	SREG = SREG ^ 0x40;
//	asm volatile("reti");
}

void
timer0_init(void)
{
	//Toggle OC0A on Compare Match
	TCCR0A = (0 << COM0A1) + (1 << COM0A0);
	// TCCR0A = 0
	// CTC mode, top = OCRA
	TCCR0A |= (1 << WGM01) + (0 << WGM00);
	TCCR0B = (0 << WGM02);
	// Prescale 256
	TCCR0B |= (1 << CS02) + (0 << CS01) + (0 << CS00);
	// Fout = F_CPU / (2 * prescale * (OCR0A + 1))
	// OCR0A = (F_CPU / (2 * prescale * Fout)) - 1
	OCR0A = tmod;

	// Enable Timer Overflow Interrupt
	TIMSK0 |= (1 << OCIE0A);
}

